import hysop.tools.numpywrappers as npw
from hysop.operator.discrete.discrete import DiscreteOperator


class CustomMonitor(DiscreteOperator):
    def __init__(self, function, res_shape=1, **kwds):
        super(CustomMonitor, self).__init__(**kwds)
        self.function = function
        self.res_shape = res_shape

    def apply(self, simulation):
        ite = simulation.currentIteration
        values = self.function(simulation,
                               self.variables)
        if self._writer is not None and self._writer.do_write(ite):
            self._writer.buffer[0, 0] = simulation.time
            self._writer.buffer[0, 1:] = values
            self._writer.write()
